// C Custom Header File
#include "frequency_band.h"

#define NUM_ELEMS(x) (sizeof(x) / sizeof((x)[0]))

typedef enum {
  DUPLEX_MODE_FDD = 0,
  DUPLEX_MODE_TDD,
  DUPLEX_MODE_SDL,
  DUPLEX_MODE_SUL,
} LTEBandDuplexMode;

struct ltebandinfo {
  unsigned int band;
  float dl_freq_min;
  int duplex_spacing;
  unsigned int dl_earfcn_min;
  unsigned int dl_earfcn_max;
  unsigned int ul_earfcn_min;
  unsigned int ul_earfcn_max;
  LTEBandDuplexMode mode;
  int bw;
};

const struct ltebandinfo bands[] = {
    {1,
     190,
     2110,
     0,
     599,
     18000,
     18599,
     DUPLEX_MODE_FDD,
     60},
    {2,
     80,
     1930,
     600,
     1199,
     18600,
     19199,
     DUPLEX_MODE_FDD,
     63},
    {3,
     95,
     1805,
     1200,
     1949,
     19200,
     19949,
     DUPLEX_MODE_FDD,
     63},
    {4,
     400,
     2110,
     1950,
     2399,
     19950,
     20399,
     DUPLEX_MODE_FDD,
     63},
    {5,
     45,
     869,
     2400,
     2649,
     20400,
     20649,
     DUPLEX_MODE_FDD,
     15},
    {6,
     45,
     875,
     2650,
     2749,
     20650,
     20749,
     DUPLEX_MODE_FDD,
     12},
    {7,
     120,
     2620,
     2750,
     3449,
     20750,
     21449,
     DUPLEX_MODE_FDD,
     60},
    {8,
     45,
     925,
     3450,
     3799,
     21450,
     21799,
     DUPLEX_MODE_FDD,
     15},
    {9,
     95,
     1844.9,
     3800,
     4149,
     21800,
     22149,
     DUPLEX_MODE_FDD,
     60},
    {10,
     400,
     2110,
     4150,
     4749,
     22150,
     22749,
     DUPLEX_MODE_FDD,
     60},
    {11,
     48,
     1475.9,
     4750,
     4949,
     22750,
     22949,
     DUPLEX_MODE_FDD,
     12},
    {12,
     30,
     729,
     5010,
     5179,
     23010,
     23179,
     DUPLEX_MODE_FDD,
     15},
    {13,
     -31,
     746,
     5180,
     5279,
     23180,
     23279,
     DUPLEX_MODE_FDD,
     12},
    {14,
     -30,
     758,
     5280,
     5379,
     23280,
     23379,
     DUPLEX_MODE_FDD,
     12},
    {17,
     30,
     734,
     5730,
     5849,
     23730,
     23849,
     DUPLEX_MODE_FDD,
     12},
    {18,
     45,
     860,
     5850,
     5999,
     23850,
     23999,
     DUPLEX_MODE_FDD,
     28},
    {19,
     45,
     875,
     6000,
     6149,
     24000,
     24149,
     DUPLEX_MODE_FDD,
     28},
    {20,
     -41,
     791,
     6150,
     6449,
     24150,
     24449,
     DUPLEX_MODE_FDD,
     60},
    {21,
     48,
     1495.9,
     6450,
     6599,
     24450,
     24599,
     DUPLEX_MODE_FDD,
     28},
    {22,
     100,
     3510,
     6600,
     7399,
     24600,
     25399,
     DUPLEX_MODE_FDD,
     60},
    {23,
     180,
     2180,
     7500,
     7699,
     25500,
     25699,
     DUPLEX_MODE_FDD,
     63},
    {24,
     -101.5,
     1525,
     7700,
     8039,
     25700,
     26039,
     DUPLEX_MODE_FDD,
     12},
    {25,
     80,
     1930,
     8040,
     8689,
     26040,
     26689,
     DUPLEX_MODE_FDD,
     63},
    {26,
     45,
     859,
     8690,
     9039,
     26690,
     27039,
     DUPLEX_MODE_FDD,
     31},
    {27,
     45,
     852,
     9040,
     9209,
     27040,
     27209,
     DUPLEX_MODE_FDD,
     15},
    {28,
     55,
     758,
     9210,
     9659,
     27210,
     27659,
     DUPLEX_MODE_FDD,
     62},
    {29,
     0,
     717,
     9660,
     9769,
     0,
     0,
     DUPLEX_MODE_SDL,
     7},
    {30,
     45,
     2350,
     9770,
     9869,
     27660,
     27759,
     DUPLEX_MODE_FDD,
     12},
    {31,
     10,
     462.5,
     9870,
     9919,
     27760,
     27809,
     DUPLEX_MODE_FDD,
     15},
    {32,
     0,
     1452,
     9920,
     10359,
     0,
     0,
     DUPLEX_MODE_SDL,
     30},
    {65,
     190,
     2110,
     65536,
     66435,
     131072,
     131971,
     DUPLEX_MODE_FDD,
     63},
    {66,
     400,
     2110,
     66436,
     67335,
     131972,
     132671,
     DUPLEX_MODE_FDD,
     63},
    {67,
     0,
     738,
     67336,
     67535,
     0,
     0,
     DUPLEX_MODE_SDL,
     30},
    {68,
     55,
     753,
     67536,
     67835,
     132672,
     132971,
     DUPLEX_MODE_FDD,
     28},
    {69,
     0,
     2570,
     67836,
     68335,
     0,
     0,
     DUPLEX_MODE_SDL,
     30},
    {70,
     300,
     1995,
     68336,
     68585,
     132972,
     133121,
     DUPLEX_MODE_FDD,
     60},
    {71,
     -46,
     617,
     68586,
     68935,
     133122,
     133471,
     DUPLEX_MODE_FDD,
     60},
    {72,
     10,
     461,
     68936,
     68985,
     133472,
     133521,
     DUPLEX_MODE_FDD,
     15},
    {73,
     10,
     460,
     68986,
     69035,
     133522,
     133571,
     DUPLEX_MODE_FDD,
     15},
    {74,
     48,
     1475,
     69036,
     69465,
     133572,
     134001,
     DUPLEX_MODE_FDD,
     63},
    {75,
     0,
     1432,
     69466,
     70315,
     0,
     0,
     DUPLEX_MODE_SDL,
     30},
    {76,
     0,
     1427,
     70316,
     70365,
     0,
     0,
     DUPLEX_MODE_SDL,
     30},
    {85,
     30,
     728,
     70366,
     70545,
     134002,
     134181,
     DUPLEX_MODE_FDD,
     12},
    {87,
     10,
     420,
     70546,
     70595,
     134182,
     134231,
     DUPLEX_MODE_FDD,
     15},
    {88,
     10,
     422,
     70596,
     70645,
     134232,
     134281,
     DUPLEX_MODE_FDD,
     15},
    {252,
     0,
     5150,
     255144,
     256143,
     0,
     0,
     DUPLEX_MODE_SDL,
     20},
    {255,
     0,
     5725,
     260894,
     262143,
     0,
     0,
     DUPLEX_MODE_SDL,
     20},
    {33,
     0,
     1900,
     36000,
     36199,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {34,
     0,
     2010,
     36200,
     36349,
     0,
     0,
     DUPLEX_MODE_TDD,
     14},
    {35,
     0,
     1850,
     36350,
     36949,
     0,
     0,
     DUPLEX_MODE_TDD,
     31},
    {36,
     0,
     1930,
     36950,
     37549,
     0,
     0,
     DUPLEX_MODE_TDD,
     31},
    {37,
     0,
     1910,
     37550,
     37749,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {38,
     0,
     2570,
     37750,
     38249,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {39,
     0,
     1880,
     38250,
     38649,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {40,
     0,
     2300,
     38650,
     39649,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {41,
     0,
     2496,
     39650,
     41589,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {42,
     0,
     3400,
     41590,
     43589,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {43,
     0,
     3600,
     43590,
     45589,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {44,
     0,
     703,
     45590,
     46589,
     0,
     0,
     DUPLEX_MODE_TDD,
     31},
    {45,
     0,
     1447,
     46590,
     46789,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {46,
     0,
     5150,
     46790,
     54539,
     0,
     0,
     DUPLEX_MODE_TDD,
     20},
    {47,
     0,
     5855,
     54540,
     55239,
     0,
     0,
     DUPLEX_MODE_TDD,
     20},
    {48,
     0,
     3550,
     55240,
     56739,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {49,
     0,
     3550,
     56740,
     58239,
     0,
     0,
     DUPLEX_MODE_TDD,
     20},
    {50,
     0,
     1432,
     58240,
     59089,
     0,
     0,
     DUPLEX_MODE_TDD,
     31},
    {51,
     0,
     1427,
     59090,
     59139,
     0,
     0,
     DUPLEX_MODE_TDD,
     7},
    {52,
     0,
     3300,
     59140,
     60139,
     0,
     0,
     DUPLEX_MODE_TDD,
     30},
    {53,
     0,
     2483.5,
     60140,
     60254,
     0,
     0,
     DUPLEX_MODE_TDD,
     7}};

unsigned int get_ul_earfcn(unsigned int dl) {
  int i;

  for (i = 0; i < NUM_ELEMS(bands); i++) {
    if ((dl >= bands[i].dl_earfcn_min) && (dl <= bands[i].dl_earfcn_max)) {
      return bands[i].ul_earfcn_min + dl - bands[i].dl_earfcn_min;
    }
  }

  return 0;
}

unsigned int get_rxrl_earfcn_ul(int bnd) {
  int i;

  for (i = 0; i < NUM_ELEMS(bands); i++) {
    if (bnd == bands[i].band) {
      return (bands[i].ul_earfcn_min + bands[i].ul_earfcn_max + 1) >> 1;
    }
  }

  return 0;
}

const char *getGSMBandCapabilityString(long bnd) {
  switch (bnd) {
    case 0:
      return "GSM 900MHz + DCS 1800MHz";
      break;
    case 1:
      return "GSM 900MHz + PCS 1900MHz";
      break;
    case 2:
      return "GSM 850MHz + DCS 1800MHz";
      break;
    case 3:
      return "GSM 850MHz + PCS 1900MHz";
      break;
    case 4:
      return "GSM 900MHz + DCS 1800MHz + PCS 1900MHz";
      break;
    case 5:
      return "GSM 850MHz + GSM 900MHz + DCS 1800MHz + PCS 1900MHz";
      break;
    default:
      return "unknown";
      break;
  }
}

const char *getUMTSBandCapabilityString(long bnd) {
  switch (bnd) {
    case 0:
      return "2100MHz (FDD I)";
      break;
    case 1:
      return "1900MHz (FDD II)";
      break;
    case 2:
      return "850MHz (FDD V)";
      break;
    case 3:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 850MHz (FDD V)";
      break;
    case 4:
      return "1900MHz (FDD II) + 850MHz (FDD V)";
      break;
    case 5:
      return "900MHz (FDD VIII)";
      break;
    case 6:
      return "2100MHz (FDD I) + 900MHz (FDD VIII)";
      break;
    case 7:
      return "1700MHz (FDD IV)";
      break;
    case 8:
      return "2100MHz (FDD I) + 850MHz (FDD V)";
      break;
    case 9:
      return "2100MHz (FDD I) + 900MHz (FDD VIII) + 850MHz (FDD V)";
      break;
    case 10:
      return "1900MHz (FDD II) + 1700MHz (FDD IV) + 850MHz (FDD V)";
      break;
    case 11:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1700MHz (FDD IV) + 850MHz (FDD V) + 900MHz (FDD VIII)";
      break;
    case 12:
      return "2100MHz (FDD I) + 1800MHz (FDD III) + 850MHz (FDD V) + 900MHz (FDD VIII)";
      break;
    case 13:
      return "1800MHz (FDD III)";
      break;
    case 14:
      return "2100MHz (FDD I) + 1800MHz (FDD III) + 850MHz (FDD V)";
      break;
    case 15:
      return "1800MHz (FDD III) + 850MHz (FDD V)";
      break;
    case 16:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1800MHz (FDD III) + 1700MHz (FDD IV) + 850MHz (FDD V) + 900MHz (FDD VIII)";
      break;
    case 17:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 900MHz (FDD VIII)";
      break;
    case 18:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1700MHz (FDD IV) + 850MHz (FDD V) + 900MHz (FDD VIII) + JAPAN1800(FDD IX) + JAPAN800(FDD XIX)";
      break;
    case 19:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1700MHz (FDD IV) + 850MHz (FDD V) + JAPAN850MHz (FDD VI) + 900MHz (FDD VIII) + JAPAN1800(FDD IX) + JAPAN800(FDD XIX)";
      break;
    case 20:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1800MHz (FDD III) + 1700MHz (FDD IV)";
      break;
    case 21:
      return "2100MHz (FDD I) + 1900MHz (FDD II) + 1800MHz (FDD III) + 1700MHz (FDD IV) + 850MHz (FDD V) + 900MHz (FDD VIII) + JAPAN1800(FDD IX) + 1500MHz (FDD XI) + JAPAN800(FDD XIX)";
      break;
    default:
      return "unknown";
      break;
  }
}